"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SoftCrudRepositoryMixin = void 0;
const tslib_1 = require("tslib");
const repositories_1 = require("../repositories");
const extend_prototype_1 = tslib_1.__importDefault(require("../decorators/extend-prototype"));
function SoftCrudRepositoryMixin(base) {
    // Using extendPrototype decorator here as Typescript doesn't support multilevel inheritance.
    // This will result in a class extending `base` class overridden with `SoftCrudRepository`'s methods and properties.
    let SoftCrudRepositoryExtended = class SoftCrudRepositoryExtended extends base {
    };
    SoftCrudRepositoryExtended = tslib_1.__decorate([
        (0, extend_prototype_1.default)(repositories_1.SoftCrudRepository)
    ], SoftCrudRepositoryExtended);
    return SoftCrudRepositoryExtended;
}
exports.SoftCrudRepositoryMixin = SoftCrudRepositoryMixin;
//# sourceMappingURL=soft-crud.repository.mixin.js.map